unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, ExtCtrls, StdCtrls,
  UnitV ;

type
  TForm5 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    n,n1,n2 : integer ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { Public 錾 }
  end;

var
  Form5: TForm5;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm5.FormShow(Sender: TObject);
begin
   n  := 100 ;
   n1 := 0 ;
   n2 := 0 ;
   with StringGrid1 do begin
      Cells[ 0,0] := 'o^ԍ';
      Cells[ 1,0] := 'O';
      Cells[ 2,0] := 'O()';
      Cells[ 3,0] := 'X֔ԍ1';
      Cells[ 4,0] := 'X֔ԍ2';
      Cells[ 5,0] := 'Z1';
      Cells[ 6,0] := 'Z2';
      Cells[ 7,0] := 'dbԍ';
      Cells[ 8,0] := 'FAXԍ';
      Cells[ 9,0] := 'gєԍ';
      Cells[10,0] := 'l';
   end;
   SCellClear ;
   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
   Button4.Enabled := True ;
   if not(Form1.IBDatabase1.Connected) then begin
      Button1.Enabled := False ;
      Button2.Enabled := False ;
      Button3.Enabled := False ;
      Button4.Enabled := False ;
      exit ;
   end;
   // e[umF
   if not(Form1.DataTableCheck(TABLE1)) then begin
      // e[u݂Ȃ̂Ńe[u쐬
      if not(Form1.DataTableMaking1) then begin
         Button1.Enabled := False ;
         Button2.Enabled := False ;
         Button3.Enabled := False ;
         Button4.Enabled := False ;
      end;
   end
   else begin
      Button1Click(Sender);
   end;
   Button1.SetFocus ;
end;

// I
procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// eNA
procedure TForm5.SCellClear ;
var
   i,j : integer ;
begin
   with StringGrid1 do begin
      for j:=1 to RowCount-1 do
         for i:=0 to ColCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm5.SCellDisplay ;
var
   i,j : integer ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE1);
         Add('  WHERE N>'+IntToStr(n1)) ;
         Add('  ORDER BY N;');
      end;
      j := 1 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         while not(IBQuery1.Eof) do begin
            for i:=0 to 10 do begin
               Form5.StringGrid1.Cells[i,j] := IBQuery1.Fields[i].AsString ;
            end;
            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
         if (j > 1) then
            n2 := SInt(Form5.StringGrid1.Cells[0,j-1]);
      except
         ;
      end;
      IBQuery1.Active := False ;
   end;
end;

// ŏ
procedure TForm5.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 0 ;
   SCellDisplay ;
end;

// O
procedure TForm5.Button2Click(Sender: TObject);
var
   i,j : integer ;
begin
   SCellClear ;
   i := 0;
   // ߂
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE1);
         Add('  WHERE N<='+IntToStr(n1)) ;
         Add('  ORDER BY N DESC;');
      end;
      j := 0 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         while not(IBQuery1.Eof) do begin
            i := SInt(IBQuery1.Fields[0].AsString);
            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
         if (IBQuery1.Eof) then i := 0;
      except
         ;
      end;
      IBQuery1.Active := False ;
   end;
   //
   n1 := i ;
   SCellDisplay ;
end;

// 
procedure TForm5.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm5.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

end.
